{$a+,b-,d-,e-,f-,g+,I-,k-,l-,n-,o-,p-,q-,r-,s-,t-,v+,x-,y-}
 {a+,b-,d-,e-,f-,g+,I-,k-,l-,n-,o-,p-,q-,r-,s-,t-,v+,x-,y-}
{$c MOVEABLE PRELOAD Discardable}
 {c MOVEABLE PRELOAD Discardable}
{$m 1024, 0, 655360}
 {m 1024, 0, 655360}

unit blank;

Interface
  Procedure BlankScreen(highres: boolean);

Implementation

uses crt,crttools,grtools;

var r         : byte;
    g         : byte;
    b         : byte;
    i         : word;
    i1        : byte;
    i2        : longint;
    colour    : array [0..255, 0..2] of byte;
    j         : word;
    Screenbuf : pointer;

Procedure GetPal(col: byte);
begin;
  port[$3c7]:=col;
  r:=port[$3c9]*4;
  g:=port[$3c9]*4;
  b:=port[$3c9]*4;
end;

Procedure Balken;
Label label1;
var   column : word;
      row    : word;
begin;
  asm; mov ax, 0013h;
       int 10h;

       mov ax, 3
       int 33h
       mov row, dx
       mov column, cx
  end;
  for i:=0 to 65 do begin;
    if i<32 then setpal(i,0,i*7,0)  {66}
    else setpal (i,0,255-(i-32)*7,0);
  end;
  for i:=66 to 134 do begin;
    if i<100 then setpal(i,(i-66)*7,0,0)
    else setpal(i,255-(i-100)*7,0,0);  {68}
  end;
  for i:=135 to 199 do begin;
    if i<167 then setpal(i,0,0,(i-135)*7)
    else setpal(i,0,0,255-(i-167)*7);  {66}
  end;
  { 1 }
  for i:=0 to 199 do
    begin;
      i2:=0;
      repeat;
        mem[$a000:i*320+i2]:=i;
        inc(i2,4);
      until i2>=321;
    end;
  for i:=199 downto 1 do
    begin;
      i2:=321;
      repeat;
        mem[$a000:i*320+i2]:=i;
        dec(i2,4);
      until i2<=0;
  end;
  for i:=0 to 199 do
    begin;
      i2:=3;
      repeat;
        mem[$a000:i*320+i2]:=i;
        inc(i2,4);
      until i2>=323;
    end;
  for i:=199 downto 0 do
    begin;
      i2:=322;
      repeat;
        mem[$a000:i*320+i2]:=i;
        dec(i2,4);
      until i2<=0;
    end;
  i:=0;
  j:=$ff;
  Label1:
    waitretrace;
    setstart(i);
    inc (i,j);
    asm
        mov ah, 1
        int 16h
      jnz @Label3
        mov ax, 3
        int 33h
        { Left button }
        mov al, bl
        and al, 1
        cmp al, 1
        je @Label3
        { Right button }
        mov al, bl
        and al, 2
        cmp al, 2
        je @Label3
        { Middle button }
        mov al, bl
        and al, 3
        cmp al, 3
        je @Label3
        { Moved ? }
        cmp cx, column
        jne @Label3
        cmp dx, row
        jne @Label3
        jmp Label1
      @Label3:
    end;
end;

Procedure FadeDown;
begin;
  for i1:=1 to 20 do begin;
    for i2:=0 to 255 do
        SetPal(i2,colour[i2,0] - colour[i2,0] div 20 * i1,
        colour[i2,1]- colour[i2,1] div 20 * i1,colour[i2,2]-colour[i2,2] div 20 * i1);
    delay(15);
  end;
  for i1:=0 to 255 do setpal(i1,0,0,0);
end;


Procedure FadeUp;
begin;
  for i1:=1 to 20 do begin;
    for i2:=0 to 255 do
      SetPal(i2,colour[i2,0] div 20 * i1,
                colour[i2,1] div 20 * i1,
                colour[i2,2] div 20 * i1);
    delay(15);
  end;
  for i1:=0 to 255 do setpal(i1,colour[i1,0],colour[i1,1],colour[i1,2]);
end;


Procedure ClearDevice;
begin;
{ 2 }
  for i:=0 to 199 do
    begin;
      i2:=0;
      repeat;
        mem[$a000:i*320+i2]:=0;
        inc(i2,4);
      until i2>=321;
    end;
  for i:=199 downto 1 do
    begin;
      i2:=321;
      repeat;
        mem[$a000:i*320+i2]:=0;
        dec(i2,4);
      until i2<=0;
  end;
  for i:=0 to 199 do
    begin;
      i2:=3;
      repeat;
        mem[$a000:i*320+i2]:=0;
        inc(i2,4);
      until i2>=323;
    end;
  for i:=199 downto 0 do
    begin;
      i2:=322;
      repeat;
        mem[$a000:i*320+i2]:=0;
        dec(i2,4);
      until i2<=0;
    end;
end;
procedure xgetscreen(start, Anzahl, s, o:word); assembler;
asm;
{ds:si}
{es:di}
  push ds
  push es

  mov  ax, $b800
  mov  ds, ax
  mov  si, start                       { DS:SI => Bildschirmadresse }

  mov  ax, s
  mov  es, ax
  mov  di, o

  mov cx, anzahl

  cld
  rep movsw

  pop es
  pop ds

  @ende:
end;

Procedure BlankScreen;
begin;
  for i1:=0 to 255 do begin;
    getpal(i1);
    colour[i1,0]:=r;
    colour[i1,1]:=g;
    colour[i1,2]:=b;
  end;
  Fadedown;
  asm; mov ax, 0002h; int 33h; end;
  getmem(screenbuf,8000);
  Pushscreen(Screenbuf,0,8000);
  balken;
  Cleardevice;
  if highres then TextMode(C80 + Font8x8) else TextMode(C80);
  EmptyBuf;
  for i1:=0 to 255 do setpal(i1,0,0,0);
  Popscreen(Screenbuf,0,8000);
  getmem(screenbuf,8000);
  asm; mov ax, 0001h; int 33h; end;
  if highres then asm
    mov cx,1
    mov dx,392
    mov ax,8
    int 33h
  end;
  cursoroff;
  Fadeup;
end;
end.